﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Reflection;

namespace MyApp
{
    class Program
    {
        const string CACHE_PATH = "TempAss";
        static void Main(string[] args)
        {
            if (Directory.Exists(CACHE_PATH) == false)
            {
                Directory.CreateDirectory(CACHE_PATH);
            }
            do
            {
                Console.Clear();
                AppDomainSetup setup = new AppDomainSetup();
                setup.ApplicationBase = AppDomain.CurrentDomain.SetupInformation.ApplicationBase;
                setup.ApplicationName = "ExtFuncs";
                setup.PrivateBinPath = "ExtDlls";
                setup.CachePath = CACHE_PATH;
                setup.ShadowCopyFiles = "true";
                AppDomain newDom = AppDomain.CreateDomain("hello", null, setup);

                newDom.DoCallBack(() =>
                {
                    /*
                    Type t = Type.GetType("TestLib.Demo, TestLib");
                    // 获取公共无参构造函数
                    ConstructorInfo costr = t.GetConstructor(new Type[] { });
                    // 调用构造函数，创建类型实例
                    object instance = costr.Invoke(new object[] { });
                    // 找到要调用的方法
                    MethodInfo m = t.GetMethod("Call", BindingFlags.Public | BindingFlags.Instance);
                    // 调用方法，得到返回值
                    object retval = m.Invoke(instance, new object[] { });
                    Console.WriteLine($"调用输出：{retval}");
                    Console.WriteLine("\n===================================");

                    // 输出引用程序集的路径
                    var refAsses = AppDomain.CurrentDomain.GetAssemblies();
                    foreach (var ass in refAsses)
                    {
                        Console.WriteLine("名称："+ ass.GetName().Name);
                        Console.WriteLine("路径：" + ass.Location);
                        Console.WriteLine();
                    }
                    */

                    TestLib.Demo dm = new TestLib.Demo();
                    Console.WriteLine($"输出：{dm.Call()}");
                });
                AppDomain.Unload(newDom); //卸载应用程序域
            }
            while (Console.ReadKey().Key != ConsoleKey.Escape);
        }
    }
}
